/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package rutherford;

import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Double;
import java.util.Random;

/**
 *
 * @author Mikulas_s_capicu
 */
public class RiadiaciThread5 extends Thread{

    private RutherfordCanvas canvas;
    boolean koniec;
    private int pocitadlo = 10;
    private Point2D.Double[] buduceDelty;

    RiadiaciThread5(RutherfordCanvas c1, boolean typ){
        canvas = c1;
        koniec = false;
        canvas.typ = typ;
        if (typ){
            buduceDelty = new Point2D.Double[10];
            buduceDelty[0] = new Point2D.Double(1,0);
            buduceDelty[1] = new Point2D.Double(0.9665, -0.2567);
            buduceDelty[2] = new Point2D.Double(0.9683, 0.2496);
            buduceDelty[3] = new Point2D.Double(0.6238, -0.7816);
            buduceDelty[4] = new Point2D.Double(0.6349, 0.7726);
            buduceDelty[5] = new Point2D.Double(-0.5719, -0.8203);
            buduceDelty[6] = new Point2D.Double(-0.5827, 0.8127);
            buduceDelty[7] = new Point2D.Double(-0.9075, -0.42);
            buduceDelty[8] = new Point2D.Double(-0.9188, 0.3948);
            buduceDelty[9] = new Point2D.Double(-1,0);
        }else{
            buduceDelty = new Point2D.Double[3];
            buduceDelty[0] = new Point2D.Double(1,0);
            buduceDelty[1] = new Point2D.Double(0.9665, -0.2567);
            buduceDelty[2] = new Point2D.Double(0.9683, 0.2496);
        }
    }

    @Override
    public void run() {
        while (! koniec){
            if (pocitadlo == 10){
                Random rand = new Random();
                int volba = rand.nextInt(8);
                AlfaCastica pom;
                switch (volba){
                    case 0:
                        Point2D.Double delta = vratBuducuDeltu();
                        pom = new AlfaCastica(68, 136, 1, 0,delta.x , delta.y);
                        break;
                    case 1:
                        pom = new AlfaCastica(63, 148, 1, 1, 0, 0);
                        break;
                    case 2:
                        pom = new AlfaCastica(51, 154, 0, 1, 0, 0);
                        break;
                    case 3:
                        pom = new AlfaCastica(39, 148, -1, 1, 0, 0);
                        break;
                    case 4:
                        pom = new AlfaCastica(34, 136, -1, 0, 0, 0);
                        break;
                    case 5:
                        pom = new AlfaCastica(39, 125, -1, -1, 0, 0);
                        break;
                    case 6:
                        pom = new AlfaCastica(51, 119, 0, -1, 0, 0);
                        break;
                    case 7:
                        pom = new AlfaCastica(63, 125, 1, -1, 0, 0);
                        break;
                    default:
                        pom = null;
                        break;
                }
                canvas.pridajCasticu(pom);
                pocitadlo = 0;
            }else{
                pocitadlo++;
            }
            canvas.posunCastice();
            if (canvas.typ){
                canvas.posunDetailCastice();
            }
            
            canvas.repaint();
            
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                System.out.println(ex.getMessage());
            }
        }
        canvas.kresliDetail = false;
        canvas.vymazVsetkyCastice();
        canvas.repaint();

    }

    private Double vratBuducuDeltu() {
        if (buduceDelty.length == 3){
            Random random = new Random();
            int volba = random.nextInt(10);
            switch (volba){
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                    return buduceDelty[0];
                case 9:
                    if (random.nextBoolean()){
                        return buduceDelty[1];
                    }else{
                        return buduceDelty[2];
                    }
            }
        }else{
            double volba = Math.random();
            if (volba<0.84){
                return buduceDelty[0];
            }else if (volba < 0.92){
                Random rand = new Random();
                if (rand.nextBoolean()){
                    return buduceDelty[1];
                }else{
                    return buduceDelty[2];
                }
            }else if (volba <0.96){
                Random rand = new Random();
                if (rand.nextBoolean()){
                    return buduceDelty[3];
                }else{
                    return buduceDelty[4];
                }
            }else if (volba <0.98){
                Random rand = new Random();
                if (rand.nextBoolean()){
                    return buduceDelty[5];
                }else{
                    return buduceDelty[6];
                }
            }else if (volba <0.99){
                Random rand = new Random();
                if (rand.nextBoolean()){
                    return buduceDelty[7];
                }else{
                    return buduceDelty[8];
                }
            }else{
                return buduceDelty[9];
            }

        }
        return null;
    }

}
